local agent_helper = require(AGENT_PATH .. "agent_helper")

AgentAdapter = {
	is_init = false,
	login_callback = nil,
	force_logout = false,
	is_login_verify_ing = false,
	login_verify_url = "cls.cp01.youyannet.com/hy1/login_verify.php",
	uid = "",
}

function PlatformAdapter:OpenExitDialog()

	agent_helper:Exit(function(result) 
		if "true" == result then
			AdapterToLua:endGame()
		end
	end)

end

-- 初始化
function AgentAdapter:Init()
	if self.is_init then return end

	local cache_data = Split((AdapterToLua:getInstance():getDataCache("PRVE_ACCOUNT_NAME") or ""), "_")
	if cache_data ~= nil then
		GLOBAL_CONFIG.package_info.config.agent_id = cache_data[1] or "hy1"
		self.uid = cache_data[2] or ""
	end

	print("===========", self.uid)
	self:SetChanneId(self.uid)

	self.is_init = true
	AgentMs:InitLocalPush()

	PlatformBinder:JsonBind("call_agent_logout", function(arg)
		self:LogoutCallback(arg)
		return true
	end)

	--2.0.0  只显示1服
	if GLOBAL_CONFIG.package_info.vername == "2.0.0" then

		for i = 1, #GLOBAL_CONFIG.server_info.server_list do
		 	if i > 1 then
		 		 GLOBAL_CONFIG.server_info.server_list[i] = nil
		 	end
	    end  
	    
	end

end

-- 平台ID
function AgentAdapter:GetSpid()
	return GLOBAL_CONFIG.package_info.config.agent_id
end

-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.uid
end

function AgentAdapter:GetChannelId()
	return "hy1"
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return "hy1_" .. self.uid
end

--获得游戏名字
function AgentAdapter:GetGameName()
	return Language.Common.GameName[25] 
end

--获得logo资源名
function AgentAdapter:GetLogoResName()

	local channel_id = PlatformBinder:JsonCall("call_get_channelId") or ""

	if channel_id == "have_logo" then
		return "big_logo_ljxl"--灵剑侠侣
	elseif channel_id == "not_logo" then
		return "empty_logo"--无
	end


	if GLOBAL_CONFIG.package_info.vername == "1.2.2" then
		return "big_logo_ljxl"--灵剑侠侣
	elseif GLOBAL_CONFIG.package_info.vername == "1.2.3" or GLOBAL_CONFIG.package_info.vername == "2.0.0" then
		return "empty_logo"--无
	end

end

--获得loadingbgname
function AgentAdapter:GetLoadingbgName()
	return "loading_bg_ljxl"
end

function AgentAdapter:LoginCallback(result)
	local json_obj = cjson.decode(result)
	self.uid = json_obj.uid

	local verify_callback = function(url, arg, data, size)
		self.is_login_verify_ing = false
		if size <= 0 then
			Log("verify_callback, fail:size<=0")
			return
		end
		local ret_t = cjson.decode(data)
		if nil == ret_t or 0 ~= ret_t.ret or nil == ret_t.user then
			Log("verify_callback, fail")
			return
		end
		self.uid = ret_t.user.uid
		self:SetChanneId(self.uid)
		LoginController.Instance:SetLoginUserData(self:GetPlatName(), ret_t.user)
		self.login_callback(self:GetPlatName())
	end

	self.is_login_verify_ing = true
	local real_url = string.format("%s?spid=%s&uid=%s&userName=%s&token=%s", self.login_verify_url, self:GetSpid(), json_obj.uid, json_obj.userName, json_obj.token)
	Log("start verify login: url=" .. real_url)
	HttpClient:Request(real_url, "", verify_callback)
end

function AgentAdapter:Login(callback)
	self.login_callback = callback
	if self.is_login_verify_ing then
		SysMsgCtrl.Instance:ErrorRemind("正在登录验证中，请稍等...", true)
		return
	end
	agent_helper:Login(LUA_CALLBACK(self, self.LoginCallback))
end


function AgentAdapter:LogoutCallback(result)
		self.uid = ""
		--if not LoginController.Instance:AgentLoginViewIsOpen() then
			ReStart()
	--	end
	return true
end

function AgentAdapter:Logout()
	self:LogoutCallback("true")
end

function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)
	local info = {}
	info.orderId = server_id .. "_" .. self:GetPlatName() .. "_" .. os.time()
	info.goods = "元宝"	
	info.money = amount * 100
	info.ext = ""

	agent_helper:Pay(cjson.encode(info), callback)
end

-- 进入游戏上报
function AgentAdapter:SubmitRoleData(role_id, role_name, role_level, zone_id, zone_name)
	local info = {}
	info.roleId = tostring(role_id)
	info.zoneId = zone_id
	info.roleName = role_name
	info.roleLevel = tostring(role_level)
	info.zoneName = zone_name
	agent_helper:SubmitExtendData(cjson.encode(info))
end

-- 角色信息返回后上报
function AgentAdapter:SubmitRoleInfoAck()
	self:SubmitInfo(1)--进入游戏上报(sdk版本3.14.2新加的setData接口)
end


--创建角色上报
function AgentAdapter:ReportOnCreateRole(role_name)
	self:SubmitInfo(0)
end


--升级上报
function AgentAdapter:ReportOnRoleLevUp(role_id, role_name, role_level, zone_id, zone_name)
	self:SubmitInfo(2)
end



function AgentAdapter:SubmitInfo(type)
	local role_vo = GameVoManager.Instance:GetMainRoleVo()
	local user_vo = GameVoManager.Instance:GetUserVo()

	if role_vo ~= nil and user_vo ~= nil then
		local info = {}
		info.zoneId = tostring(user_vo.plat_server_id)
		info.zoneName = user_vo.plat_server_id .. "服-" .. user_vo.plat_server_name
		info.roleName = role_vo.name
		info.roleId = tostring(role_vo.role_id)
		info.roleLevel = tostring(role_vo.level) or "0"
		--上报创建角色时间
		if type == 0 then
			info.roleCTime = tostring(os.time())
		else
			info.roleCTime = tostring(role_vo.role_create_time) or "0"
		end
		
		info.ext = ""
		print(cjson.encode(info))
		PlatformBinder:JsonCall("send_user_info", cjson.encode(info))
	end
end


-- 是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end

channelIds = {}
channelIds["2966064400"] = "y00"		--HTC	    
channelIds["344534282"] = "y01"			--豌豆荚	    
channelIds["3837941030"] = "y02"		--oppo		    
channelIds["2357097034"] = "y03"		--vivo		    
channelIds["2016803597"] = "y04"		--酷派		    
channelIds["1369376444"] = "y05"		--应用汇5		    
channelIds["2081603487"] = "y06"		--应用宝		    
channelIds["4180306041"] = "y07"		--当乐V4		    
channelIds["1876218605"] = "y08"		--UC优视游戏		    
channelIds["1370308097"] = "y09"		--小米	    
channelIds["1990796034"] = "y0a"		--360		    
channelIds["3259016037"] = "y0b"		--百度多酷		    
channelIds["452499687"] = "y0c"			--华为	    


function AgentAdapter:SetChanneId(channeld)
	if "" ~= self.uid then
		local split_data = Split(self.uid, "-")
		if nil ~= split_data then
			channeld = split_data[1] or ""
			print("channeld====", channeld)
			GLOBAL_CONFIG.package_info.config.agent_id = channelIds[channeld] or "hy1"
			print("channeld==", GLOBAL_CONFIG.package_info.config.agent_id)
		end
	end
end