require("gameui/ui_config/role_ui_cfg")
require("game/role/role_data")
require("game/role/equip_data")
require("game/role/role_view")
require("game/role/role_items")
require("game/role/role_bag_view")
require("game/role/role_attr_view")
require("game/role/role_skill_view")
require("game/role/role_title_view")
require("game/role/role_fashion_view")
require("game/role/change_head_view")
require("game/role/role_rename")
require("game/role/role_rename_guild")
--------------------------------------------------------------
--角色相关，如属性，装备等
--------------------------------------------------------------
RoleCtrl = RoleCtrl or BaseClass(BaseController)
function RoleCtrl:__init()
	if RoleCtrl.Instance then
		ErrorLog("[RoleCtrl] Attemp to create a singleton twice !")
	end
	RoleCtrl.Instance = self
	self.role_data = RoleData.New()
	self.role_view = RoleView.New()
	self.rename_view = RoleRename.New()
	self.rename_guild_view = RoleRenameGuildView.New()
	self.change_head_view = ChangeHeadView.New()
	self:RegisterAllProtocols()

	self.delay_protocol_list = {}
	self.is_has_roledata = false

	GlobalEventSystem:Bind(ObjectEventType.FIGHT_EFFECT_CHANGE, BindTool.Bind1(self.OnFightEffectChange, self))
	self.money_info = {
		coin = 0,
		gold = 0,
		bind_gold = 0
	}
end

function RoleCtrl:__delete()
	RoleCtrl.Instance = nil

	self.role_data:DeleteMe()
	self.role_data = nil
	self.role_view:DeleteMe()
	self.role_view = nil
	self.rename_view:DeleteMe()
	self.rename_view = nil
	self.change_head_view:DeleteMe()
	self.change_head_view = nil
	self.delay_protocol_list = nil
	
	if self.money_show_delay then
		GlobalTimerQuest:CancelQuest(self.money_show_delay)
		self.money_show_delay = nil
	end
end

function RoleCtrl:RegisterAllProtocols()
	--人物属性
	self:RegisterProtocol(SCLevelChange, "OnLevelChange")
	self:RegisterProtocol(SCRoleChangeProf, "OnRoleChangeProf")
	self:RegisterProtocol(SCRoleAttributeValue, "OnRoleAttributeValue")
	self:RegisterProtocol(SCChaExpChange, "OnChaExpChange")
	self:RegisterProtocol(SCRoleInfoAck, "OnRoleInfoAck")
	self:RegisterProtocol(SCMoneyChange, "OnMoneyChange")
	self:RegisterProtocol(SCRoleAddCamp, "OnRoleAddCamp")
	self:RegisterProtocol(SCRoleNameColorChange, "OnRoleNameColorChange")
	self:RegisterProtocol(SCRoleEvilChange, "OnRoleEvilChange")
	self:RegisterProtocol(SCCapabilityChange, "OnCapabilityChange")
	self:RegisterProtocol(SCRoleXianhun, "OnRoleXianhun")
	self:RegisterProtocol(SCRoleYuanli, "OnRoleYuanli")
	self:RegisterProtocol(SCRoleNuqi, "OnRoleNuqi")
	self:RegisterProtocol(SCRoleShuxingdanPercentInfo, "OnRoleShuxingdanPercentInfo")
	self:RegisterProtocol(SCBattleFieldHonorChange, "OnBattleFieldHonorChange")
	self:RegisterProtocol(SCOtherUserOnlineStatus, "OnOtherUserOnlineStatus")
	self:RegisterProtocol(SCRoleShengwang, "OnSCRoleShengwang")

	--人物装备列表
	self:RegisterProtocol(SCEquipList, "OnEquipList")
	self:RegisterProtocol(SCEquipChange,"OnEquipChange")
	self:RegisterProtocol(CSTakeOffEquip)

	self:RegisterProtocol(CSSetAvatarTimeStamp)

	-- 更名
	self:RegisterProtocol(CSRoleResetName)
	self:RegisterProtocol(SCRoleResetName, "OnRoleResetName")
	self:RegisterProtocol(CSGuildResetName)
end

function RoleCtrl:Open(index, param_t)
	if param_t ~= nil and param_t.sub_view_name == SubViewName.ReName then
		self.rename_view:Open()
		return
	end

	if param_t ~= nil and param_t.sub_view_name == SubViewName.ReNameGuild then
		self.rename_guild_view:Open()
		return
	end

	self.role_view:Open()
	if nil ~= index then
		self.role_view.tabbar:OnClickCallback(index)
	end
	--打开礼包
	if nil ~= param_t and nil ~= param_t.open_param and true == param_t.open_param.select_first_gift then
		local bag_item_list = ItemData.Instance:GetBagItemDataList()
		for k,v in pairs(bag_item_list) do
			local item_config = ItemData.Instance:GetItemConfig(v.item_id)
			if nil ~= Config.gift_auto[v.item_id] and RoleData.Instance.role_vo.level >= item_config.limit_level then
				local index = math.floor(k / 20)
				self.role_view.bag_radio:SelectIndex(index)
				self.role_view.bag_grid:SelectCellByIndex(k)
				break
			end
		end
	end

	if nil ~= param_t and nil ~= param_t.open_param then
		if true == param_t.open_param.select_tili_jiu then
			--打开体力酒
			self:SelectBagFirstItemById(22050)
		elseif true == param_t.open_param.open_yuyi_item then
			--打开洁白之翼
			self:SelectBagFirstItemById(22042)
		end
	end
	--激活服装
	if nil ~= param_t and nil ~= param_t.open_param and nil ~= param_t.item_id and "fashion" == param_t.open_param then
		local type, index = FashionData.Instance:GetFashionTypeAndIndexById(param_t.item_id)
		if nil ~= type and nil ~= index then
			self.role_view:UseActFashion(type, index )
		end
	end
end

function RoleCtrl:SelectBagFirstItemById(item_id)
	if nil == self.role_view or nil == self.role_view.bag_grid then
		return
	end
	local bag_item_list = ItemData.Instance:GetBagItemDataList()
	for k,v in pairs(bag_item_list) do
		if item_id == v.item_id then
			local index = math.floor(k / 20)
			self.role_view.bag_radio:SelectIndex(index)
			self.role_view.bag_grid:SelectCellByIndex(k)
			break
		end
	end
end

function RoleCtrl:OpenChangeHead()
	if self.change_head_view then
		self.change_head_view:Open()
	end
end

function RoleCtrl:Close()
	self.role_view:Close()
	self.change_head_view:Close()
end

--请求全部信息，必须进入场景后且主ui加载完成
function RoleCtrl:SendReqAllInfo()
	if Scene.Instance:GetSceneConfig() and MainuiCtrl.Instance:GetView():IsLoaded() then
		Log("RoleCtrl:SendReqAllInfo")
		local protocol = CSAllInfoReq.New()
		protocol:EncodeAndSend()
	end
end

--登陆时主角角色信息返回
function RoleCtrl:OnRoleInfoAck(protocol)
	Log("RoleCtrl:OnRoleInfoAck")

	local main_role_vo = GameVoManager.Instance:GetMainRoleVo()
	AvatarManager.Instance:SetAvatarKey(main_role_vo.role_id, protocol.attr_t.avatar_key_big, protocol.attr_t.avatar_key_small)

	for k,v in pairs(protocol.attr_t) do
		RoleData.Instance:SetMainRoleVoValue(k, v)
	end

	main_role_vo.base_move_speed = Scene.ServerSpeedToClient(protocol.attr_t.base_move_speed)
	main_role_vo.move_speed = Scene.ServerSpeedToClient(protocol.attr_t.move_speed)

	--创建场景角色
	Scene.Instance:CreateMainRole()
	--打开主界面
	if not MainuiCtrl.Instance.view:IsOpen() then
		MainuiCtrl.Instance:Open()
		local scene_type = Scene.Instance:GetSceneType()
		MainuiCtrl.Instance:ChangeMainuiBySceneType(0, scene_type)
	end

	--设置角色体力
	local energy = main_role_vo.energy
	SupplyData.Instance:SetEnergy(energy)

	self.is_has_roledata = true
	self:DoDelayProtocolList()

	RoleData.Instance:RoleInfoOk()
	if self.role_view:IsLoaded() then  --如果不预加载，这块是无用的
		self.role_view:FluchRoleAttrViewAll()
		self.role_view:InitAllSkillList()
		self.role_view:CreateRoleModel()
	end

	GlobalEventSystem:Fire(LoginEventType.RECV_MAIN_ROLE_INFO)

	if AgentAdapter.SubmitRoleInfoAck then
		AgentAdapter:SubmitRoleInfoAck()
	end


end

--角色、怪物信息改变
function RoleCtrl:OnRoleAttributeValue(protocol)
	local obj = Scene.Instance:GetObjectByObjId(protocol.obj_id)
	if obj == nil or not obj:IsCharacter() then
	 	return
	end

	for k,v in pairs(protocol.attr_pair_list) do
		local attr_name = RoleData.Instance:GetRoleAttrNameByType(v.attr_type)

		-- 加血特效
		if attr_name == "hp" and v.attr_value > obj:GetVo().hp then
			obj:PlayAddHpEffect()
		end
		
		obj:SetRoleVoValue(attr_name, v.attr_value)	--场景人物信息改变
	end
end

function RoleCtrl:GetHasDelayShowMoney()
	return self.delay_show_money
end

function RoleCtrl:SetHasDelayShowMoney(value)
	if self.money_show_delay and self.delay_show_money == true and value == false then
		GlobalTimerQuest:CancelQuest(self.money_show_delay)
		self.money_show_delay = nil
		self:SetMoneyChange()
	end

	self.delay_show_money = value
end


--金钱改变
function RoleCtrl:OnMoneyChange(protocol)
	self.money_info.coin = protocol.coin
	self.money_info.bind_gold = protocol.bind_gold
	self.money_info.gold = protocol.gold
	if self.delay_show_money then
		if self.money_show_delay == nil then
			self.money_show_delay = GlobalTimerQuest:AddDelayTimer(BindTool.Bind1(self.SetMoneyChange,self), 5)
		end
	else
		self:SetMoneyChange()
	end

	--奥塞姆元宝数量上报
	if AgentAdapter.OnMoneyChange ~= nil then
		if protocol.gold ~= nil and protocol.bind_gold ~= nil then
			AgentAdapter:OnMoneyChange(protocol.gold + protocol.bind_gold)
		end
	end
	
end

function RoleCtrl:SetMoneyChange()
	self.delay_show_money = false

	local role_info = RoleData.Instance:GetRoleInfo()

	if nil ~= role_info.coin and self.money_info.coin > role_info.coin then
		SystemHint.Instance:FloatingLabel(string.format(Language.SysRemind.AddCoin, self.money_info.coin - role_info.coin))
	end
	if nil ~= role_info.bind_gold and self.money_info.bind_gold > role_info.bind_gold then
		SystemHint.Instance:FloatingLabel(string.format(Language.SysRemind.AddGoldBind, self.money_info.bind_gold - role_info.bind_gold))
	end
	if nil ~= role_info.gold and self.money_info.gold > role_info.gold then
		SystemHint.Instance:FloatingLabel(string.format(Language.SysRemind.AddGold, self.money_info.gold - role_info.gold))
	end

	RoleData.Instance:SetMainRoleInfoValue("gold", self.money_info.gold)
	RoleData.Instance:SetMainRoleInfoValue("bind_gold", self.money_info.bind_gold)
	RoleData.Instance:SetMainRoleInfoValue("coin", self.money_info.coin)
	RoleData.Instance:SetMainRoleInfoValue("bind_coin", self.money_info.bind_coin)
	Remind.Instance:DoRemind(RemindId.want_some_gold)
end

--经验改变
function RoleCtrl:OnChaExpChange(protocol)
	RoleData.Instance:SetMainRoleVoValue("exp", protocol.exp)
	local sign = protocol.delta > 0 and "+" or ""
	SystemHint.Instance:FloatingLabel(string.format(Language.SysRemind.AddExp, sign .. protocol.delta))
end

--等级改变
function RoleCtrl:OnLevelChange(protocol)
	local obj = Scene.Instance:GetObjectByObjId(protocol.obj_id)
	if obj ~= nil and obj:IsRole() then
	 	obj:SetRoleVoValue("level", protocol.level)
		obj:SetRoleVoValue("exp", protocol.exp)
		obj:SetRoleVoValue("max_exp", protocol.max_exp)
		--升级后刷新活动里面的投资计划可领取数量
		Remind.Instance:DoRemind(RemindId.invest_plan)
		Remind.Instance:DoRemind(RemindId.manytowerfb)

		--充值界面各种弹窗
		local main_role_vo = GameVoManager.Instance:GetMainRoleVo()
		if main_role_vo.obj_id == protocol.obj_id then
			--首冲界面
			if protocol.level == 20 or protocol.level == 40 then
				local chong_zhi_info = ServerActivityData.Instance:GetTotalChongZhiData()
				if chong_zhi_info.history_recharge_count < 1 then
					ServerActivityCtrl.Instance:OpenFirstRechargeView({open_param = COMMON_CONSTS.ZORDER_RECHARGE_PANEL})
				end
			end
			--超值送礼
			if protocol.level == 30 then
				if FunOpen.Instance:GetFunIsOpened(FunName.SuperGift) then
					SuperGiftCtrl.Instance:Open()
				end
			end
			if MainProber.Step2 then 
				MainProber.role_level = protocol.level
				MainProber:Step2(2100, MainProber.user_id, MainProber.server_id, MainProber.role_name, MainProber.role_id, MainProber.role_level) 
			end

			local user_vo = GameVoManager.Instance:GetUserVo()
			if AgentAdapter.ReportOnRoleLevUp and main_role_vo ~= nil then
				local zone_name = user_vo.plat_server_id .. "服-" .. user_vo.plat_server_name
				AgentAdapter:ReportOnRoleLevUp(main_role_vo.role_id, main_role_vo.role_name, main_role_vo.level, main_role_vo.server_id, zone_name)
			end
		end
	end
end

--飞升转职
function RoleCtrl:OnRoleChangeProf(protocol)
	local obj = Scene.Instance:GetObjectByObjId(protocol.obj_id)
	if obj ~= nil and obj:IsRole() then
		obj:SetRoleVoValue("prof", protocol.prof)
		obj:SetRoleVoValue("max_hp", protocol.max_hp)
	end
	MainuiCtrl.Instance:UpdataSkillStarLayout()
end

--战斗力变更
function RoleCtrl:OnCapabilityChange(protocol)
	RoleData.Instance:SetMainRoleVoValue("capability", protocol.capability)
end

--仙魂变化
function RoleCtrl:OnRoleXianhun(protocol)
	local delta_xianhun = protocol.xianhun - GameVoManager.Instance:GetMainRoleVo().xianhun
	if delta_xianhun > 0 then
		SystemHint.Instance:FloatingLabel(string.format(Language.SysRemind.AddXianHun, delta_xianhun))
	end

	RoleData.Instance:SetMainRoleVoValue("xianhun", protocol.xianhun)
	Remind.Instance:DoRemind(RemindId.skill_learn)
	Remind.Instance:DoRemind(RemindId.skill_levelup)
end

--精元变化(真气)
function RoleCtrl:OnRoleYuanli(protocol)
	local delta_yuanli = protocol.yuanli - GameVoManager.Instance:GetMainRoleVo().yuanli
	if delta_yuanli > 0 then
		SystemHint.Instance:FloatingLabel(string.format(Language.SysRemind.AddZhenQi, delta_yuanli))
	end

	RoleData.Instance:SetMainRoleVoValue("yuanli", protocol.yuanli)
	Remind.Instance:DoRemind(RemindId.train_meridian)
end

--怒气变化
function RoleCtrl:OnRoleNuqi(protocol)
	RoleData.Instance:SetMainRoleVoValue("nuqi", protocol.nuqi)
end

-- 属性丹百分比
function RoleCtrl:OnRoleShuxingdanPercentInfo(protocol)
	RoleData.Instance:SetMainRoleVoValue("shuxingdan_percent", protocol.shuxingdan_percent)
end

--荣誉积分
function RoleCtrl:OnBattleFieldHonorChange(protocol)
	RoleData.Instance:SetMainRoleVoValue("honour", protocol.honor)
	if protocol.delta_honor > 0 then
		SystemHint.Instance:FloatingLabel(string.format(Language.SysRemind.AddHonor, protocol.delta_honor))
	end
end

--声望
function RoleCtrl:OnSCRoleShengwang(protocol)
	local shengwang = protocol.shengwang - GameVoManager.Instance:GetMainRoleVo().shengwang
	SystemHint.Instance:FloatingLabel(string.format(Language.SysRemind.AddShengWang, shengwang))
	RoleData.Instance:SetMainRoleVoValue("shengwang", protocol.shengwang)
end

--其它玩家在线信息改变
function RoleCtrl:OnOtherUserOnlineStatus(protocol)
	GlobalEventSystem:Fire(OtherEventType.ROLE_ONLINE_CHANGE, protocol.role_id, protocol.is_online)
end

--加入阵营
function RoleCtrl:OnRoleAddCamp(protocol)
	local obj = Scene.Instance:GetObjectByObjId(protocol.obj_id)
	if obj ~= nil and obj:IsRole() then
	 	obj:SetRoleVoValue("camp", protocol.camp)
	end
	local main_role_vo = GameVoManager.Instance:GetMainRoleVo()
	if main_role_vo.obj_id == protocol.obj_id then
		Remind.Instance:DoRemind(RemindId.capital_can_get_tax)
	end
end

--角色名字颜色改变
function RoleCtrl:OnRoleNameColorChange(protocol)
	local obj = Scene.Instance:GetObjectByObjId(protocol.obj_id)
	if obj ~= nil and obj:IsRole() then
	 	obj:SetRoleVoValue("name_color", protocol.name_color)
	 	-- obj:GetVo().name_color = protocol.name_color
		obj:UpdateNameBoard()
		obj:UpdateTitle()
	end
end

--罪恶值值改变
function RoleCtrl:OnRoleEvilChange(protocol)
	local role_vo = RoleData.Instance.role_vo
	local dif_evil = protocol.evil - role_vo.evil
	local sign = dif_evil > 0 and "+" or ""
	local evil_dec = "{wordcolor;ff0000;" .. string.format(Language.SysRemind.AddEvil, sign .. dif_evil) .. "}"
	SystemHint.Instance:FloatingLabel(evil_dec)
	RoleData.Instance:SetMainRoleVoValue("evil", protocol.evil)
end

--装备列表
function RoleCtrl:OnEquipList(protocol)
	EquipData.Instance:SetDataList(protocol.equip_list, protocol.fabao_info)
end

--单个装备改变
function RoleCtrl:OnEquipChange(protocol)
	EquipData.Instance:ChangeDataInGrid(protocol.equip_data)
end

--脱下装备
function RoleCtrl:CSTakeOffEquip(index)
	local cmd = ProtocolPool.Instance:GetProtocol(CSTakeOffEquip)
	cmd.index = index
	cmd:EncodeAndSend(GameNet.Instance:GetGameServerNetId())
end

-- 打开技能界面
function RoleCtrl:OpenSkillView()
	self:Open()

	-- 打开宝石界面
	self.role_view.tabbar:OnClickCallback(3)
end

function RoleCtrl:GetIsHasRoleData()
	return self.is_has_roledata
end

--注册延迟理协议，针对角色属性未返回时，其他需要用到角色属性的协议先返回
--服务端设计上的问题
function RoleCtrl:RegisterDelayProtocol(fun, protocol)
	if self.is_has_roledata then
		return 
	end
	self.delay_protocol_list[#self.delay_protocol_list + 1] = fun
end
--角色属性返回后处理注册的延迟协议
function RoleCtrl:DoDelayProtocolList()
	for k,v in pairs(self.delay_protocol_list) do
		v()
	end
end

function RoleCtrl:OnFightEffectChange(is_main_role)
	if is_main_role and self.role_view:IsLoaded() then
		self.role_view:FlushBuffAttr()
	end
end

-- 修改头像
function RoleCtrl.SendSetAvatarTimeStamp(avatar_key_big, avatar_key_small)
	local protocol = ProtocolPool.Instance:GetProtocol(CSSetAvatarTimeStamp)
	protocol.avatar_key_big = avatar_key_big
	protocol.avatar_key_small = avatar_key_small
	protocol:EncodeAndSend()
end

-- 修改名称
function RoleCtrl.SendRoleResetName(new_name, is_item_reset)
	local protocol = ProtocolPool.Instance:GetProtocol(CSRoleResetName)
	protocol.is_item_reset = is_item_reset
	protocol.new_name = new_name
	protocol:EncodeAndSend()
end


-- 修改仙盟名称
function RoleCtrl.SendGuildResetName(new_name, guild_id)
	guild_id = guild_id or RoleData.Instance.role_vo.guild_id
	local protocol = ProtocolPool.Instance:GetProtocol(CSGuildResetName)
	protocol.guild_id = guild_id
	protocol.new_name = new_name
	protocol:EncodeAndSend()
end

-- 名称修改
function RoleCtrl:OnRoleResetName(protocol)
	local name = protocol.game_name
	local obj_id = protocol.obj_id
	if obj_id == Scene.Instance.main_role:GetObjId() then-- 如果是自己
		local obj = Scene.Instance.main_role
		if obj then
			RoleData.Instance:SetMainRoleVoValue("name", name)
			RoleData.Instance:SetMainRoleVoValue("role_name", name)
			obj:GetVo().name = name or ""
			obj:GetVo().role_name = name or ""
			obj:UpdateNameBoard()
			SysMsgCtrl.Instance:ErrorRemind(Language.Role.ChangeNameSuc)
		end

		local main_role_vo = GameVoManager.Instance:GetMainRoleVo()
		local user_vo = GameVoManager.Instance:GetUserVo()
		if AgentAdapter.SubmitRoleData and main_role_vo ~= nil then
			local zone_name = user_vo.plat_server_id .. "服-" .. user_vo.plat_server_name
			AgentAdapter:SubmitRoleData(main_role_vo.role_id, main_role_vo.role_name, main_role_vo.level, main_role_vo.server_id, zone_name)
		end
	else
		for k,v in pairs(Scene.Instance.obj_list) do
			if v:GetObjId() == obj_id then
				v:GetVo().name = name or ""
				v:UpdateNameBoard()
			end
		end
	end
end
